package com.sosopay.trade;

import java.util.UUID;

import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.protocol.HTTP;

import com.sosopay.base.TradeConfig;
import com.sosopay.model.Refund;
import com.sosopay.util.CommonUtil;
import com.sosopay.util.HttpProtocolHandler;
import com.sosopay.util.JsonMapper;

/**
 * 退款接口
 */
public class RefundTrade {

	public static void main(String[] args) throws Exception {
		
		String chargeCode = "9A1C13A1-5438-48E7-9C38-804FA9F68284"; //交易上行流水号
		String chargeDownCode = UUID.randomUUID().toString();//交易下行流水号
		System.out.println(chargeDownCode);
		
		Refund f = new Refund();
		f.setBUSI_ID(TradeConfig.BUSI_ID);
		f.setCHARGE_CODE(chargeCode);
		f.setCHARGE_REFUND_FEE("0.01");
		f.setDEV_ID("devid1");
		f.setOPER_ID("test1");
		f.setOUT_REFUND_NO("");
		f.setREFUND_SUBJECT("退款");

		String jsonString = JsonMapper.getInstance().toJson(f);
	
		//计算签名。 计算签名的时候要把xml中的空白符全部去掉 ，编码统一用utf-8。
		String  reqJson = jsonString;
		
		
		System.out.println(reqJson);
		reqJson = reqJson.replaceAll("\\s", "");
		long timestamp = System.currentTimeMillis();// 
		
		//商户key 98SDKFUO432HNODS098EEE07U9DUOIUE  每个商户分配一个 这个是测试的
		//生成签名规则 md5(timestamp+key+xml):timestamp
		String s = CommonUtil.md5Encrypt(timestamp + TradeConfig.BUSI_KEY + reqJson) + ":" + timestamp;
		// HttpPost连接对象
		HttpPost httpPost = new HttpPost(TradeConfig.REQ_URL + "refund" + "?sign=" + s + "&_type=json&busiCode=" + TradeConfig.BUSI_ID);
		System.setProperty("jsse.enableSNIExtension", "false");

		StringEntity entity = new StringEntity(jsonString,"UTF-8");
		httpPost.setEntity(entity);

		httpPost.setHeader(HTTP.CONTENT_TYPE, "text/xml;charset=utf-8");

		//soso接口返回 详细定义参考嗖嗖接口文档
        //https 提交请求
        String httpResponse = HttpProtocolHandler.getInstance().executeHttps(httpPost);
        //http 提交请求
//      String httpResponse = HttpProtocolHandler.getInstance().execute(httpPost);

		System.out.println(httpResponse);
	}
}
