package com.sosopay.trade;

import java.util.UUID;

import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.protocol.HTTP;

import com.sosopay.base.TradeConfig;
import com.sosopay.model.Goods;
import com.sosopay.model.Order;
import com.sosopay.util.CommonConstants;
import com.sosopay.util.CommonUtil;
import com.sosopay.util.HttpProtocolHandler;
import com.sosopay.util.JsonMapper;

/**
 * 微信公众号支付下单demo
 */
public class WeixinOrderTrade {

	public static void main(String[] args) throws Exception {

		// 模拟订单
		Order order = new Order();
		order.setAMT("0.1");
		order.setBUSI_ID(TradeConfig.BUSI_ID); // 测试用的商户编码
		order.setCHANNEL_TYPE(CommonConstants.CHANNEL_TYPE_WEIXIN+"");
		order.setDEV_ID("qqqq");
		order.setOPER_ID("test1"); //操作员编号
		order.setPAY_SUBJECT("嗖嗖产品1");
		order.setNODIFY_URL("http://uat.sssyin.cn:9000/openGateway/openService/"); // 商户异步回调地址
		String chargeCode = UUID.randomUUID().toString();
		order.setCHARGE_CODE(chargeCode); // 上行流水号 你们自己的流水号 需要保证唯一
//		order.setREGISTER_ID("02016");//门店编号 配置子商户（口碑活动）时候需要，默认不传
		order.setMERCHANTPARA("嗖嗖产品");//自定义参数，交易成功以后接口返回
		order.setTRADE_TYPE("JSAPI");
		order.setSubAppid("wxb1c959c78e070e58");
		order.setSubOpenid("oa58kwTYbuSGryFQKk8SOu-VMi-M");
		
		// 没有商品明细时候
		// order.setGoods(new ArrayList<Goods>());
		// 模拟商品
		Goods good = new Goods();
		good.setGOOD_CLASS("商品类型");
		good.setGOOD_ID("商品id");
		good.setGOOD_NAME("商品名称");
		good.setGOOD_PRICE("2.00");
		good.setGOOD_SUBJECT("商品描述");
		good.setGOOD_QUANTITY("5");
		good.setGOOD_SHOWURL("www.****.com"); // 商品展示网址
		order.addGoods(good);

		Goods good2 = new Goods();
		good2.setGOOD_CLASS("商品类型");
		good2.setGOOD_ID("商品id");
		good2.setGOOD_NAME("商品名称");
		good2.setGOOD_PRICE("2.00");
		good2.setGOOD_SUBJECT("商品描述");
		good2.setGOOD_QUANTITY("5");
		good2.setGOOD_SHOWURL("www.****.com");
		order.addGoods(good2);

		String jsonString = JsonMapper.getInstance().toJson(order);
		
		System.out.println(jsonString);

		// 请求主扫接口
		// 计算签名。 计算签名的时候要把xml中的空白符全部去掉 ，编码统一用utf-8。
		String reqJson = jsonString;
		reqJson = reqJson.replaceAll("\\s", "");
		long timestamp = System.currentTimeMillis();//
		
		// 商户key 98SDKFUO432HNODS098EEE07U9DUOIUE 每个商户分配一个 这个是测试的
		// 生成签名规则 md5(timestamp+key+xml):timestamp
		String s = CommonUtil.md5Encrypt(timestamp + TradeConfig.BUSI_KEY + reqJson) + ":" + timestamp;
		// HttpPost连接对象
		HttpPost httpPost = new HttpPost(TradeConfig.REQ_URL + "order" + "?sign=" + s + "&_type=json&busiCode=" + TradeConfig.BUSI_ID);
		System.setProperty("jsse.enableSNIExtension", "false");

		StringEntity entity = new StringEntity(jsonString, "UTF-8");
		httpPost.setEntity(entity);

		httpPost.setHeader(HTTP.CONTENT_TYPE, "text/xml;charset=utf-8");
		
		//soso接口返回 详细定义参考嗖嗖接口文档
		
		//https 提交请求
		String httpResponse = HttpProtocolHandler.getInstance().executeHttps(httpPost);
		//http 提交请求
//		String httpResponse = HttpProtocolHandler.getInstance().execute(httpPost);

		// 请求返回结果
		System.out.println(httpResponse);
	}

}
