package com.sosopay.util;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.StringReader;
import java.io.StringWriter;
import java.io.UnsupportedEncodingException;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.PropertyException;
import javax.xml.bind.Unmarshaller;

/**
 * 
 * 
 */
public class CommonUtil {
	public static final String YMD = "yyyy-MM-dd";
	public static final String YMDHMS = "yyyy-MM-dd HH:mm:ss";
	
	 public static String readFileByLines(String fileName) {
		    StringBuffer sb = new StringBuffer();
		    File file = new File(fileName);
		    BufferedReader reader = null;
		    try {
		      System.out.println("以行为单位读取文件内容，一次读一整行：");
		      reader = new BufferedReader(new FileReader(file));
		      String tempString = null;
		      int line = 1;

		      while ((tempString = reader.readLine()) != null)
		      {
		        System.out.println("line " + line + ": " + tempString);
		        sb.append(tempString);
		        line++;
		      }
		      reader.close();
		    } catch (IOException e) {
		      e.printStackTrace();
		    } finally {
		      if (reader != null)
		        try {
		          reader.close();
		        }
		        catch (IOException e1) {
		        }
		    }
		    return sb.toString();
		  }
	
	public static String md5Encrypt(String str) throws Exception{
		try {
			MessageDigest md = MessageDigest.getInstance("MD5");
			md.update(str.getBytes("UTF-8"));
			byte b[] = md.digest();

			int i;

			StringBuffer buf = new StringBuffer();
			for (int offset = 0; offset < b.length; offset++) {
				i = b[offset];
				if (i < 0)
					i += 256;
				if (i < 16)
					buf.append("0");
				buf.append(Integer.toHexString(i));
			}
			return buf.toString();


		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	public static String stringWithDateAndFormat(Date date,String format){
		if(date != null){
			SimpleDateFormat sdf = new SimpleDateFormat(format);
			return sdf.format(date);
		}
		return "";
	}
	
	public static Date dateWithStringAndFormat(String dateStr,String format){
		if(dateStr!=null){
			SimpleDateFormat sdf = new SimpleDateFormat(format);
			try {
				return sdf.parse(dateStr);
			} catch (ParseException e) {
				e.printStackTrace();
			}
		}
		return null;
	}
	public static void printProperties(Object obj){
		Field[] fields = obj.getClass().getDeclaredFields();
		Field.setAccessible(fields, true);
		for(Field f:fields){
				try {
					System.out.println(f.getName()+" : "+f.get(obj));
				} catch (IllegalArgumentException e) {
					e.printStackTrace();
				} catch (IllegalAccessException e) {
					e.printStackTrace();
				}
		}
	}
	public static void printAllPropertiesFromGetMethod(Object obj){
		Method[] methods = obj.getClass().getMethods();
		Method.setAccessible(methods, true);
		for(Method m:methods){
			String name = m.getName();
			if(name.startsWith("get")){
				name = name.substring(3,name.length());
				try {
					System.out.println(name+" : "+m.invoke(obj, new Object[0]));
				} catch (IllegalAccessException e) {
					e.printStackTrace();
				} catch (IllegalArgumentException e) {
					e.printStackTrace();
				} catch (InvocationTargetException e) {
					e.printStackTrace();
				}
			}
		}
	}
	public static void copyDeclaredFields(Object originalObject,Object targetObject,boolean isIgnoreCase){
		Field[] oriFields = originalObject.getClass().getDeclaredFields();
		Field[] tarFields = targetObject.getClass().getDeclaredFields();
		Field.setAccessible(oriFields, true);
		Field.setAccessible(tarFields, true);
		for(Field f1:oriFields){
			for(Field f2:tarFields){
				if(isIgnoreCase?f1.getName().equalsIgnoreCase(f2.getName()):f1.getName().equals(f2.getName())){
					try {
						f2.set(targetObject, f1.get(originalObject));
					} catch (IllegalArgumentException e) {
						e.printStackTrace();
					} catch (IllegalAccessException e) {
						e.printStackTrace();
					}
				}
			}
		}
	}
	
	public static void copyAllFieldFromGetterAndSetter(Object originalObject,Object targetObject){
		Method[] methods1 = originalObject.getClass().getMethods();
		Method.setAccessible(methods1, true);
		
		Method[] methods2 = targetObject.getClass().getMethods();
		Method.setAccessible(methods2, true);
		
		for(Method m1:methods1){
			String name1 = m1.getName();
			if(name1.startsWith("get")){
				name1 = name1.substring(3, name1.length());
				for(Method m2:methods2){
					String name2 = m2.getName();
					if(name2.startsWith("set")){
						name2 = name2.substring(3,name2.length());
						if(name1.equals(name2)){
							try {
								m2.invoke(targetObject, m1.invoke(originalObject, new Object[0]));
							} catch (IllegalAccessException e) {
								e.printStackTrace();
							} catch (IllegalArgumentException e) {
								e.printStackTrace();
							} catch (InvocationTargetException e) {
								e.printStackTrace();
							}
						}
					}
				}
			}
		}
	}
	
	public static String Obj2XML(Object obj,Class<?> clazz) {
		try {
			JAXBContext jaxbContext = JAXBContext.newInstance(clazz);
			Marshaller jaxbMarshaller = jaxbContext.createMarshaller();
			jaxbMarshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, true);
			StringWriter write = new StringWriter();
			jaxbMarshaller.marshal(obj, write);
			String out = write.getBuffer().toString();
			return out;
		} catch (PropertyException e) {
			e.printStackTrace();
			return "";
		} catch (JAXBException e) {
			e.printStackTrace();
			return "";
		}
	}
	
	public static Object XML2Obj(String xml,Class<?> clazz) {
		StringReader reader =null;
		try {
			JAXBContext jaxbContext = JAXBContext
					.newInstance(clazz);
			reader = new StringReader(xml);
			Unmarshaller jaxbUnmarshaller = jaxbContext.createUnmarshaller();
			Object Obj = jaxbUnmarshaller.unmarshal(reader);
			reader.close();
			return Obj;
		} catch (PropertyException e) {
			e.printStackTrace();
			return null;
		} catch (JAXBException e) {
			e.printStackTrace();
			return null;
		}finally{
			if(reader!=null){
				reader.close();
			}
		}
	}
	
	public static InputStream getInputStream(String fileName) {
		try {
			InputStream a = new FileInputStream(fileName);
			return a;
		} catch (IOException e) {
			e.printStackTrace();
			return null;
		}
	}
	
	public static String desDecrypt(String src, String st, String en, String password){
		byte[] keybyte = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
		int temp = password.length()<24?password.length():24;
		for(int i = 0; i< temp; i++){
			keybyte[i] = (byte)password.charAt(i);
		}
		String temp_s = src.substring(src.indexOf(st) + st.length(), src.indexOf(en));
		try {
			byte[] decryResult = DES.decryptMode(keybyte, Base64Util.decrypt(temp_s));
			return src.replace(st + temp_s + en, st + new String(decryResult, "UTF-8") + en);
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return "";
	}
	
	public static String desEncrypt(String src, String st, String en, String password){
		byte[] keybyte = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
		int temp = password.length()<24?password.length():24;
		for(int i = 0; i< temp; i++){
			keybyte[i] = (byte)password.charAt(i);
		}
		String temp_s = src.substring(src.indexOf(st) + st.length(), src.indexOf(en));
		try {
			byte[] decryResult = DES.encryptMode(keybyte, temp_s.getBytes("UTF-8"));
			return src.replace(st + temp_s + en, st + Base64Util.encode(decryResult) + en);
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return "";
	}
	
	/**
	 * @param src
	 * @param password
	 * @return
	 */
	public static String desDecrypt(String src, String password){
		byte[] keybyte = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
		int temp = password.length()<24?password.length():24;
		for(int i = 0; i< temp; i++){
			keybyte[i] = (byte)password.charAt(i);
		}
		
		try {
			byte[] decryResult = DES.decryptMode(keybyte, Base64Util.decrypt(src));
			return new String(decryResult, "UTF-8");
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return "";
	}
	
	public static String desEncrypt(String src, String password){
		byte[] keybyte = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
		int temp = password.length()<24?password.length():24;
		for(int i = 0; i< temp; i++){
			keybyte[i] = (byte)password.charAt(i);
		}
		
		try {
			byte[] decryResult = DES.encryptMode(keybyte, src.getBytes("UTF-8"));
			return Base64Util.encode(decryResult).replaceAll("[\\s*\t\n\r]", "");
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return "";
	}
}
